/*****************************************************************************
 * $Id: tape.h,v 1.1.1.1 1992/01/06 20:27:43 ak Exp $
 *****************************************************************************
 * $Log: tape.h,v $
 * Revision 1.1.1.1  1992/01/06  20:27:43  ak
 * Interface now based on ST01 and ASPI.
 * AHA_DRVR no longer supported.
 * Files reorganized.
 *
 * Revision 1.1  1992/01/06  20:27:41  ak
 * Initial revision
 *
 *****************************************************************************/

/*
 * Tape control.
 */

extern void	tape_init ();
extern void	tape_term ();

extern int	tape_reset (int bus);

extern void	tape_trace(int);

extern int	tape_target (int);
extern void	tape_sense (void *data, int len);	/* >= 8, NULL resets */

extern char *	tape_error (int);

extern int	tape_cmd (void *cdb, int cdb_len);
extern int	tape_read_cmd (void *cdb, int cdb_len,
			       void far *data, long data_len);
extern int	tape_write_cmd (void *cdb, int cdb_len,
			        void far *data, long data_len);

extern int	tape_inquiry (void *data, int len);
extern int	tape_mode_sense (int page, void *data, int len);
extern int	tape_mode_select (int page, void *data, int len, int SMP);

extern int	tape_rewind (int imed);
extern int	tape_space (int mode, long nitems, long *actual);
extern long	tape_tell (void);   			/* Tandberg */
extern int	tape_seek (int imed, long blkno);	/* Tandberg */

extern int	tape_read (void far *data, long length, long nblocks, long *actual);
extern int	tape_compare (void far *data, long length, long nblocks, long *actual);
extern int	tape_verify (long nblocks, long *actual);

extern int	tape_write (void far *data, long length, long nblocks, long *actual);
extern int	tape_filemark (int imed, long nblocks);
extern int	tape_erase (void);

extern int	tape_buffered_write (void far *data, long length, long nblocks, long *actual);
extern int	tape_buffered_wait (long *actual);

extern int	tape_ready (void);
extern int	tape_load (int imed, int retension);
extern int	tape_unload (int imed, int mode);

extern void	tape_print_sense (FILE *file, int retcode);

/* Space mode: */
enum SpaceMode {
	SpaceBlocks = 0,
	SpaceFileMarks = 1,
	SpaceSeqFileMarks = 2,
	SpaceLogEndOfMedia = 3
};

/* Unload mode */
enum UnloadMode {
	UnloadRewind = 0,
	UnloadRetension = 1,
	UnloadEndOfTape = 2
};

/* additional error codes, -> scsi.h */
#define TapeError	0x4000

#define EndOfData	TapeError+1
#define EndOfTape	TapeError+2
#define FileMark	TapeError+3
#define NoCommand	TapeError+4	/* buffered_wait */
